#!/bin/sh

connect_discovery_servers_on_host()
{
  INFOFILE=$1/nvme_info
  HOSTNM=`basename $1`
  if [ -f ${INFOFILE} ] ; then
    WWNN=`cat /sys/class/fc_host/${HOSTNM}/node_name`
    WWPN=`cat /sys/class/fc_host/${HOSTNM}/port_name`
    HOST_TRADDR="nn-${WWNN}:pn-${WWPN}"
    cat ${INFOFILE} | awk -v haddr=${HOST_TRADDR} '/^NVME RPORT.*DISCSRVC/{print "/usr/sbin/nvme connect-all --transport=fc --host-traddr=" haddr " --traddr=nn-0" $6 ":pn-0" $4 }' | bash
  fi
}

# need a real check for root permissions here
ROOT=1

if [ $ROOT -ne 1 ] ; then
  echo "$0: Must be root to execute"
  exit 1
fi

for f in /sys/class/scsi_host/* ; do
  connect_discovery_servers_on_host $f
done
